﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace SuperDumpService.Models {
	public class BundleMetainfo {
		public string BundleId { get; set; }
		public string BundleFileName {get;set;} // original filename. just informational.
		public DateTime Created { get; set; }
		public DateTime Finished { get; set; }
		public BundleStatus Status { get; set; }
		public IDictionary<string, string> CustomProperties { get; set; } = new Dictionary<string, string>();
		public string ErrorMessage { get; set; }
		public string FileHash { get; set; }
		public string OriginalBundleId { get; set; }

		public override string ToString() {
			return BundleId;
		}
	}

	public enum BundleStatus {
		Created, Downloading, Analyzing, Finished, Failed, Duplication
	}
}
